function varargout = CellViewer_V4_2(varargin)
% CellViewer_V4_2 MATLAB code for CellViewer_V4_2.fig
%      CellViewer_V4_2, by itself, creates a new CellViewer_V4_2 or raises the existing
%      singleton*.
%
%      H = CellViewer_V4_2 returns the handle to a new CellViewer_V4_2 or the handle to
%      the existing singleton*.
%
%      CellViewer_V4_2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CellViewer_V4_2.M with the given input arguments.
%
%      CellViewer_V4_2('Property','Value',...) creates a new CellViewer_V4_2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CellViewer_V4_2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CellViewer_V4_2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CellViewer_V4_2

% Last Modified by GUIDE v2.5 29-May-2017 09:41:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @CellViewer_V4_2_OpeningFcn, ...
    'gui_OutputFcn',  @CellViewer_V4_2_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CellViewer_V4_2 is made visible.
function CellViewer_V4_2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CellViewer_V4_2 (see VARARGIN)

% Choose default command line output for CellViewer_V4_2
handles.output = hObject;
global showlegend
showlegend=get(handles.checkbox_showlegend,'Value');
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes CellViewer_V4_2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);
% --- Outputs from this function are returned to the command line.
function varargout = CellViewer_V4_2_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function outputcells=mapcellposition(importmat)
for i=1:size(importmat,1)
    outputcells(i,1)=importmat{i,2}; %x-coordinates
    outputcells(i,2)=importmat{i,3}; %y-coordinates
    outputcells(i,3)=importmat{i,4}; %z-coordinates
    if importmat{i,6} == 0           % if no color is set
        outputcells(i,4)=1;          %set grey
    else
        outputcells(i,4)=importmat{i,6}; %set defined colo
    end
    
    if size(importmat,2)<12
        outputcells(i,5)=0.5;             %set 50%
    else
        if isempty(importmat{i,12}) || importmat{i,12} == 2 % if no alpha is set
            outputcells(i,5)=0.5; %set 50%
        else
            outputcells(i,5)=importmat{i,12}; %set defined alpha
        end
    end
    
% % %     1    2    3      4      5         
% % %     x    y    z    color   0.5
end

% --- Executes on button press in button_loadfile.
function button_loadfile_Callback(hObject, eventdata, handles)
% hObject    handle to button_loadfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clearvars -global exportmat Go selection cells file path RegressorNames

global exportmat Go selection file path region
set(handles.listbox_cellselect, 'String','');
selection=1;
[file, path, filesuccess]=uigetfile( ...
    {'*.mat','MATLAB Files (*.mat)'}, ...
    'Pick a file named afer exportedcellshybrid');
if isempty(file) || filesuccess==0
    errordlg('No valid file selected.')
    return;
end
load([path file]);
if exist('exportmat_total')
    exportmat=exportmat_total;
end
%test if file contains information about brain region and prompt user if
%not
if size(exportmat,2)<10
    disp('It seems you are using an outdated data format.\n')
    regionselect = input('Please press "1" and Enter for "midbrain" or "2" and Enter for "hindbrain":');
    choices={'midbrain';'hindbrain'};
    exportmat(:,10)=deal(choices(regionselect));
end

if strcmpi(exportmat{1,10},'midbrain') 
    region=1;
elseif strcmpi(exportmat{1,10},'hindbrain') 
    region=2;
else region=inputdlg(sprintf('Brain region not specified.\nEnter 1 for midbrain or 2 for hindbrain.'));

end
set(handles.listbox_cellselect, 'String', 1:size(exportmat,1));
set(handles.listbox_cellselect, 'Value',1);


% --- Executes on button press in button_viewallcells.
function button_viewallcells_Callback(hObject, eventdata, handles)
% hObject    handle to button_viewallcells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat cells region h_cam
cells=mapcellposition(exportmat);
h_cam=show3dposition_5_131005(cells,get(handles.checkbox_shownumbers,'Value'),region,get(handles.checkbox_showlegend,'Value'),'non-classified cells');
camlight(h_cam,'left')

% --- Executes on button press in button_viewclassifiedsuperthreshold.
function button_viewclassifiedsuperthreshold_Callback(hObject, eventdata, handles)
% hObject    handle to button_viewclassifiedsuperthreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat region h_cam
if size(exportmat,2)<12
    errordlg('You seem to use an old file format that does not support this function. You might want to consider re-analyzing your data with a newer version of MOMLoad.')
end
cells=mapcellposition(exportmat);
cells_filtered=FilterConfiguration(cells,get(handles.checkbox_showlegend,'Value'));


% --- Executes on button press in pushbutton_classifybyDSI.
function pushbutton_classifybyDSI_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_classifybyDSI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat region h_cam
if size(exportmat,2)<28
    errordlg('This function requires "exportedcellshybrid" files. Use the "ConvertAriRegionStatsTo_CellViewer" script to generate these files from "RegionStats" and "exportedcells" files.');
else
    cells=mapcellposition(exportmat);
    cells(:,5)=cell2mat(exportmat(:,28));
    cells(:,5)=round((cells(:,5)+1)*50);
    cells(cells(:,5)<=0,5)=1;
    cells(cells(:,5)>100,5)=100;
    h_cam=show3dposition_5_131005_DSI(cells,get(handles.checkbox_shownumbers,'Value'),region,get(handles.checkbox_showlegend,'Value'),'non-classified cells');
camlight(h_cam,'left')
end


% --- Executes on button press in pushbutton_classifyMulitreg.
function pushbutton_classifyMulitreg_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_classifyMulitreg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat region h_cam

%from Fumi's version 3_1: 256 regressor data: 
if size(exportmat,2)<17
    errordlg('You seem to use an old file format that does not support this function. You might want to consider re-analyzing your data with a newer version of MOMLoad.')
end

cells=mapcellposition(exportmat);
cells_filtered=RegFilterConfiguration(cells,get(handles.checkbox_showlegend,'Value'));

% --- Executes on button press in button_viewselected.
function button_viewselected_Callback(hObject, eventdata, handles)
% hObject    handle to button_viewselected (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat selection cells Go region h_cam
cells=mapcellposition(exportmat);
cells(:,4)=1;
cells(selection,4)=2;
h_cam=show3dposition_5_131005(cells,get(handles.checkbox_shownumbers,'Value'),region,get(handles.checkbox_showlegend,'Value'),{'non-classified cells';'selected cell'});
showcellactivity(exportmat, selection);
% tilefigs;

function showcellactivity(cellstats,cellno)
try close(99); end
h=figure(99);
hold on
ndatapoints=length(cellstats{cellno,7});
for j=1:size(cellstats{1,8},2)
    temp=(cellstats{cellno,8}(:,j)-min(cellstats{cellno,8}(:,j)))/(max(cellstats{cellno,8}(:,j))-min(cellstats{cellno,8}(:,j))); %normalized
    plot(temp-j*2,'r','LineWidth',2);
    plot(cellstats{cellno,7}-j*2, 'LineWidth',2);
    corrCoeff=cellstats{cellno,9}(1,j);
    t=text(ndatapoints+2,-j*2+0.5,num2str(corrCoeff,'%1.2f'));
    if corrCoeff >= 0.4
        set(t, 'FontWeight', 'bold', 'Color', [0,0.5,0]);
    elseif corrCoeff <= -0.4
        set(t, 'FontWeight', 'bold', 'Color', [0.5,0,0]);
    end
end
title(['Cell ' num2str(cellno) ' DFF and convolved regressors']);

% --- Executes on button press in pushbutton_showactivity.
function pushbutton_showactivity_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_showactivity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global selection exportmat
showcellactivity(exportmat, selection);

% --- Executes on selection change in listbox_cellselect.
function listbox_cellselect_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_cellselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_cellselect contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_cellselect
global selection
selection = get(handles.listbox_cellselect,'Value');

% --- Executes during object creation, after setting all properties.
function listbox_cellselect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_cellselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_savevideo.
function pushbutton_savevideo_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_savevideo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat cells file path region h_cam
%show3dposition_5_131005(cells,0, region);
if ishandle(98)
figure(98);

 filename=[path file(1:end-4) '_3Dmovie.avi'];
  % fix aspect ratio
  axis vis3d;
  xlim([-150,150]);
  ylim([-250,75]);
  zlim([-100,100]);
  % create file
  set(gcf, 'Position', [10 10 1024 768])
  movie1=avifile(filename,'fps',4,'compression','none');
  

  view([270 90]);
  for j=1:10
      	camlight(h_cam,'left')
      drawnow;
      movie1=addframe(movie1,gcf);
  end
  
  for j=1:4:80
      view([270 90-j]);
      	camlight(h_cam,'left')
      drawnow;
      movie1=addframe(movie1,gcf);
  end
  
  for j=1:10
      	camlight(h_cam,'left')
      drawnow;
      movie1=addframe(movie1,gcf);
  end
  
  for i=1:4:90
    view([i+270 10]);
    	camlight(h_cam,'left')
    drawnow;
    movie1=addframe(movie1,gcf);
  end
  
  for j=1:10
      	camlight(h_cam,'left')
      drawnow;
      movie1=addframe(movie1,gcf);
  end
  
  for i=91:4:360
    view([i+270 10]);
    	camlight(h_cam,'left')
    drawnow;
    movie1=addframe(movie1,gcf);
  end

  for j=1:4:80
    view([270 j+10]);
    	camlight(h_cam,'left')
    drawnow;
    movie1=addframe(movie1,gcf);
  end
  
  movie1=close(movie1);
  
  else
    errordlg('Please plot the cells first');
end


% --- Executes on button press in pushbutton_exportorthogviews.
function pushbutton_exportorthogviews_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_exportorthogviews (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ishandle(98)
figure(98);

global exportmat cells file path region h_cam
%show3dposition_5_131005(cells,0, region);
set(gcf, 'Position', [10 10 1024 768])
 filename=[path file(1:end-4)];
  % fix aspect ratio
  axis vis3d;
  xlim([-130,130]);
  ylim([-220,40]);
  zlim([-100,100]);

  view(270,90);
        	camlight(h_cam,'left')
  saveas(98,[filename '_frontal'], 'png');
  saveas(98,[filename '_frontal'], 'fig');
  saveas(98,[filename '_frontal'], 'epsc');
  view(270,0);
        	camlight(h_cam,'left')
  saveas(98,[filename '_sagittal'], 'png');
  saveas(98,[filename '_sagittal'], 'fig');
  saveas(98,[filename '_sagittal'], 'epsc');
  view(0,0);
        	camlight(h_cam,'left')
  saveas(98,[filename '_transversal_back'], 'png');
  saveas(98,[filename '_transversal_back'], 'fig');
  saveas(98,[filename '_transversal_back'], 'epsc');
  view(180,0);
        	camlight(h_cam,'left')
  saveas(98,[filename '_transversal_front'], 'png');
  saveas(98,[filename '_transversal_front'], 'fig');
  saveas(98,[filename '_transversal_front'], 'epsc');
  else
    errordlg('Please plot the cells first');
end


% --- Executes on button press in checkbox_shownumbers.
function checkbox_shownumbers_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_shownumbers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_shownumbers


% --- Executes on button press in pushbutton_LateralView.
function pushbutton_LateralView_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_LateralView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global h_cam
figure(98);
  xlim([-130,130]);
  ylim([-220,40]);
  zlim([-100,100]);
  
view(270,0);
camlight(h_cam,'left')





% --- Executes on button press in pushbutton_CoronalView.
function pushbutton_CoronalView_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_CoronalView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global h_cam
figure(98);
  xlim([-130,130]);
  ylim([-220,40]);
  zlim([-100,100]);
view(180,0); %from front
% view(0,0); %131016
camlight(h_cam,'left')

% 
% % --- Executes on button press in pushbutton_FrontalView.
% function pushbutton_FrontalView_Callback(hObject, eventdata, handles)
% % hObject    handle to pushbutton_FrontalView (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% figure(98);


% --- Executes on button press in pushbutton_DorsalView.
function pushbutton_DorsalView_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_DorsalView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global h_cam
figure(98);
%   xlim([-150,150]);
%   ylim([-250,75]);
%   zlim([-100,100]);
  xlim([-130,130]);
  ylim([-220,40]);
  zlim([-100,100]);
view(270,90);
camlight(h_cam,'left')


% --- Executes on button press in checkbox_showlegend.
function checkbox_showlegend_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_showlegend (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global showlegend;
showlegend=get(hObject,'Value');
% Hint: get(hObject,'Value') returns toggle state of checkbox_showlegend

% % % % % % % % % % % % % % % % % % % 
% % --- Executes on button press in button_viewallcells.
% function button_viewallcells_Callback(hObject, eventdata, handles)
% % hObject    handle to button_viewallcells (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)

% % % % % % % % % % % % % % % % % % % % % 

% --- Executes on button press in cell_boundary_button.
function cell_boundary_button_Callback(hObject, eventdata, handles)
% hObject    handle to cell_boundary_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global exportmat region cell_boundaryt
boundary_legend=cell(5,1);
boundary_legend{1,1}='Above the bounday';
boundary_legend{2,1}='Below the bounday';
boundary_legend{3,1}='On the bounday';
boundary_legend{4,1}='Unclear';
boundary_legend{5,1}='The boundary';


cells=mapcellposition(exportmat);
new_cells=zeros(size(cells,1)+size(cell_boundaryt,1),5);
new_cells(1:size(cells,1),:)=cells(:,:);
new_cells((1+size(cells,1)):end,:)=cell_boundaryt(:,:);
hh_cam=show3dposition_boundary(new_cells,get(handles.checkbox_shownumbers,'Value'),region,get(handles.checkbox_showlegend,'Value'),boundary_legend);
camlight(hh_cam,'left')


% --- Executes on button press in load_boundary_button.
function load_boundary_button_Callback(hObject, eventdata, handles)
% hObject    handle to load_boundary_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global cell_boundaryt

[file_boundary, path_boundary, filesuccess]=uigetfile( ...
    {'*.mat','MATLAB Files (*.mat)'}, ...
    'Pick a boundary file named afer exported boundary of brain');
if isempty(file_boundary) || filesuccess==0
    errordlg('No valid file selected.')
    return;
end

load([path_boundary file_boundary]);
disp('files are loaded');


% --- Executes on button press in Highlight_Cells.
function Highlight_Cells_Callback(hObject, eventdata, handles)
% hObject    handle to Highlight_Cells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% % % kw 2016/11/03
global exportmat cell_boundaryt
if size(exportmat,2)<12
    errordlg('You seem to use an old file format that does not support this function. Please check the format of your data.')
end
cells=mapcellposition(exportmat);
new_cells=zeros(size(cells,1)+size(cell_boundaryt,1),5);
new_cells(1:size(cells,1),:)=cells(:,:);
new_cells((1+size(cells,1)):end,:)=cell_boundaryt(:,:);
length_of_cells=size(cells,1);
HighlightConfiguration(new_cells,get(handles.checkbox_showlegend,'Value'),length_of_cells);
% HighlightConfiguration(cells,get(handles.checkbox_showlegend,'Value'),0);


% --- Executes on button press in Highlight_Cells_RFs.
function Highlight_Cells_RFs_Callback(hObject, eventdata, handles)
% hObject    handle to Highlight_Cells_RFs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% % % kw 2016/11/03
global exportmat cell_boundaryt
if size(exportmat,2)<12
    errordlg('You seem to use an old file format that does not support this function. Please check the format of your data.')
end
cells=mapcellposition(exportmat);
new_cells=zeros(size(cells,1)+size(cell_boundaryt,1),5);
new_cells(1:size(cells,1),:)=cells(:,:);
new_cells((1+size(cells,1)):end,:)=cell_boundaryt(:,:);
length_of_cells=size(cells,1);
Highlight_RFs_Configuration(new_cells,get(handles.checkbox_showlegend,'Value'),length_of_cells);


% --- Executes on button press in Highlight_Cells_Binocular.
function Highlight_Cells_Binocular_Callback(hObject, eventdata, handles)
% hObject    handle to Highlight_Cells_Binocular (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% % % kw 2017/05/29
global exportmat cell_boundaryt
if size(exportmat,2)<12
    errordlg('You seem to use an old file format that does not support this function. Please check the format of your data.')
end
cells=mapcellposition(exportmat);
new_cells=zeros(size(cells,1)+size(cell_boundaryt,1),5);
new_cells(1:size(cells,1),:)=cells(:,:);
new_cells((1+size(cells,1)):end,:)=cell_boundaryt(:,:);
length_of_cells=size(cells,1);

Highlight_Binucular_cells_Configuration(new_cells,get(handles.checkbox_showlegend,'Value'),length_of_cells);
