%% Load pooled cell list file
[CVfile, CVpath, filesuccess]=uigetfile( ...
    {'*.mat','MATLAB Files (*.mat)'}, ...
    'Pick a pooled cell collection');
if isempty(CVfile) || filesuccess==0
    errordlg('No valid Cell list file selected.')
    return;
end
load([CVpath CVfile],'exportmat');

[RSfile, RSpath filesuccess]=uigetfile( ...
    {'*.mat','MATLAB Files (*.mat)'}, ...
    'Pick a pooled region stats file (from 256 reg analysis)');
if isempty(RSfile) || filesuccess==0
    errordlg('No valid PooledRegionStats file selected.')
    return;
end
load([RSpath RSfile], 'MergedRegionStats');

MergedRegionStatsCell=permute(struct2cell(MergedRegionStats),[3,1,2]);
validlist=zeros(size(exportmat,1),1);
exportmat(:,13:20)=cell(size(exportmat,1),8);

%% Scan every cell in exportmat for match in RegionStats file
h=waitbar(0,'Processing...');
for k=1:size(exportmat,1)
    waitbar(k/size(exportmat,1),h,['Processing...(Cell ' num2str(k) ' of ' num2str(size(exportmat,1)) ')'])
    for i=1:size(MergedRegionStatsCell,1)
        if find(isequal(exportmat(k,9),MergedRegionStatsCell(i,5))) %% if matched element is found...
            exportmat(k,13:20)=MergedRegionStatsCell(i,11:18); validlist(k,1)=validlist(k,1)+1; %% ...append additional information from RegionStats
        end
    end
end
close(h)

unmatchedlist=cell(length(validlist),1);
for l=1:length(validlist)
    if validlist(l)==0
                unmatchedlist{l,1}=exportmat{l,1}(1,2);
    end
end
emptyCells = cellfun(@isempty,unmatchedlist);
unmatchedlist(emptyCells) = [];

%Sanity check
if max(validlist)>1
    errordlg('Multiple matching RegionStats entries found for one cell. Aborting...')
else
    disp(['Success. ' num2str(numel(find(validlist))) ' data pairs matched.']);
end
exportmat=exportmat(find(validlist),:);
save([CVpath CVfile(1:end-4) '_exportedcellshybrid.mat'], 'exportmat');
