function varargout = Highlight_RFs_Configuration(varargin)
% HIGHLIGHT_RFS_CONFIGURATION MATLAB code for Highlight_RFs_Configuration.fig
%      HIGHLIGHT_RFS_CONFIGURATION, by itself, creates a new HIGHLIGHT_RFS_CONFIGURATION or raises the existing
%      singleton*.
%
%      H = HIGHLIGHT_RFS_CONFIGURATION returns the handle to a new HIGHLIGHT_RFS_CONFIGURATION or the handle to
%      the existing singleton*.
%
%      HIGHLIGHT_RFS_CONFIGURATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in HIGHLIGHT_RFS_CONFIGURATION.M with the given input arguments.
%
%      HIGHLIGHT_RFS_CONFIGURATION('Property','Value',...) creates a new HIGHLIGHT_RFS_CONFIGURATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Highlight_RFs_Configuration_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Highlight_RFs_Configuration_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Highlight_RFs_Configuration

% Last Modified by GUIDE v2.5 27-Mar-2019 16:18:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Highlight_RFs_Configuration_OpeningFcn, ...
                   'gui_OutputFcn',  @Highlight_RFs_Configuration_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Highlight_RFs_Configuration is made visible.
function Highlight_RFs_Configuration_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Highlight_RFs_Configuration (see VARARGIN)

% Choose default command line output for Highlight_RFs_Configuration
handles.output = hObject;

global cellmatrix original_cellmatrix Alpha_value test_inhibition

original_cellmatrix = cell2mat(varargin(1));
cellmatrix = original_cellmatrix(1:varargin{3},:);

High_Lightcolumndata=get(handles.High_Light_RF,'Data');
High_Lightcolumndata(:,[1,13])={false};           %140107
High_Lightcolumndata(:,[2,6,10])={'RF size'};
High_Lightcolumndata(:,[3,7,11])={'=='};
High_Lightcolumndata(:,[4,8,12])={0};

matrix_1=repmat(0:5,1,6);
[x,~]=meshgrid(1:6);
matrix_2=reshape(x,1,36);

matrix_2=reshape(x,1,36);

for ii=1:size(High_Lightcolumndata,1)-2
    High_Lightcolumndata(ii,4)={matrix_1(ii)};
    High_Lightcolumndata(ii,8)={matrix_2(ii)};
end

High_Lightcolumndata(:,5)={'DONE'};
High_Lightcolumndata(:,9)={'DONE'};
set(handles.High_Light_RF,'Data',High_Lightcolumndata);
Alpha_value=0.5;
set(handles.Edit_Alpha_RF,'String','0.5');
test_inhibition=get(handles.Test_Inhibition,'Value');
set(handles.radiobutton_All,'Value',1)
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes Highlight_RFs_Configuration wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Highlight_RFs_Configuration_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Show_Cells_RF.
function Show_Cells_RF_Callback(hObject, eventdata, handles)
% hObject    handle to Show_Cells_RF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global filtersettings exportmat cellmatrix region filternames showlegend h_cam original_cellmatrix Alpha_value test_inhibition 

show_choice=get(handles.radiobutton_All,'Value')*3+get(handles.radiobutton_Tectum,'Value')+2*get(handles.radiobutton_Pretectum,'Value');
% 2017/06/28

test_inhibition=get(handles.Test_Inhibition,'Value');
        
exportmat_editted=select_cell_type(exportmat,get(handles.Pop_RF_Type,'Value'));

filtersettings=get(handles.High_Light_RF,'Data');
output=cellmatrix;

tempresult_left=zeros(size(exportmat_editted,1),size(filtersettings,1));
tempresult_right=tempresult_left;

number_of_colors=sum(cell2mat(filtersettings(:,1)));
shown_index=double(cell2mat(filtersettings(:,end)));
if ~shown_index
    errordlg('please check at least one shown checker box','Selection Error');
end


finallogical=tempresult_left;
clear filternames
for k=1:size(filtersettings,1)
    
    factor_index=0;
    if strcmpi('RF size',filtersettings(k,2))
         factor_index=1;                                 % the size varies between 1-5
    elseif strcmpi('RF center_x',filtersettings(k,2))
         factor_index=1;                                 % the x varies between 1-6
    elseif strcmpi('RF center_y',filtersettings(k,2))
         factor_index=1;                                 % the y varies between 1-6
    else
         disp('Please choose from RF properties.')
    end
    
    if strcmpi(filtersettings(k,9),'&&') || strcmpi(filtersettings(k,9),'||')
        filternames{k,1}=[filtersettings{k,2} filtersettings{k,3}, num2str(factor_index*filtersettings{k,4}),...
            filtersettings{k,5}, filtersettings{k,6},filtersettings{k,7}, num2str(factor_index*filtersettings{k,8}),...
            filtersettings{k,9}, filtersettings{k,10},filtersettings{k,11}, num2str(factor_index*filtersettings{k,12})];   
    else        
       if strcmpi(filtersettings(k,5),'&&') || strcmpi(filtersettings(k,5),'||')
            filternames{k,1}=[filtersettings{k,2} filtersettings{k,3}, num2str(factor_index*filtersettings{k,4}),...
            filtersettings{k,5}, filtersettings{k,6},filtersettings{k,7}, num2str(factor_index*filtersettings{k,8})];
       else
            filternames{k,1}=[filtersettings{k,2}, filtersettings{k,3}, num2str(factor_index*filtersettings{k,4})];
       end  
    end
    
    exportmat_index=0;
    
    if strcmpi('RF size',filtersettings(k,2))
         exportmat_index=22;
    elseif strcmpi('RF center_x',filtersettings(k,2))
         exportmat_index=19;
    elseif strcmpi('RF center_y',filtersettings(k,2))
         exportmat_index=20;
    else
         disp('Please choose from RF properties.')
    end
    
    if  exportmat_index 
       if filtersettings{k,1}==1
         for m=1:size(exportmat_editted,1)
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
exportmat_index=update_exportmat_index_online(filtersettings,k,2);   %
% added on 2017/06/30 updates index  % comments 2018/03/20

% % % % %  three columns of filters  % % % % % %
            temp=exportmat_editted{m,exportmat_index};                                                        %left side filter
            if strcmpi(filtersettings(k,3),'>')
                tempresult_left(m,k)=temp.*(temp>filtersettings{k,4});
                templogical_left(m,k)=temp>filtersettings{k,4};
            elseif strcmpi(filtersettings(k,3),'<=')
                tempresult_left(m,k)=temp.*(temp<=filtersettings{k,4});
                templogical_left(m,k)=temp<=filtersettings{k,4};
            elseif strcmpi(filtersettings(k,3),'==')                     % added on 2017/06/30
                tempresult_left(m,k)=temp.*(temp==filtersettings{k,4});
                templogical_left(m,k)=temp==filtersettings{k,4};
            end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %             
              exportmat_index=update_exportmat_index_online(filtersettings,k,6);   % added on 2017/06/30 updates index
            if strcmpi(filtersettings(k,5),'&&') || strcmpi(filtersettings(k,5),'||') %middle filter
                temp=exportmat_editted{m,exportmat_index};   
                if strcmpi(filtersettings(k,7),'>')
                    tempresult_middle(m,k)=temp.*(temp>filtersettings{k,8});
                    templogical_middle(m,k)=temp>filtersettings{k,8};
                elseif strcmpi(filtersettings(k,7),'<=')
                    tempresult_middle(m,k)=temp.*(temp<=filtersettings{k,8});
                    templogical_middle(m,k)=temp<=filtersettings{k,8};
                elseif strcmpi(filtersettings(k,7),'==')                % added on 2017/06/30
                    tempresult_middle(m,k)=temp.*(temp==filtersettings{k,8});
                    templogical_middle(m,k)=temp==filtersettings{k,8};
                end
            end  
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %             
              exportmat_index=update_exportmat_index_online(filtersettings,k,10);   % added on 2017/06/30 updates index
            if strcmpi(filtersettings(k,9),'&&') || strcmpi(filtersettings(k,9),'||') %right side filter
                temp=exportmat_editted{m,exportmat_index};   
                if strcmpi(filtersettings(k,11),'>')
                    tempresult_right(m,k)=temp.*(temp>filtersettings{k,12});
                    templogical_right(m,k)=temp>filtersettings{k,12};
                elseif strcmpi(filtersettings(k,11),'<=')
                    tempresult_right(m,k)=temp.*(temp<=filtersettings{k,12});
                    templogical_right(m,k)=temp<=filtersettings{k,12};
                elseif strcmpi(filtersettings(k,11),'==')               % added on 2017/06/30
                    tempresult_right(m,k)=temp.*(temp==filtersettings{k,12});
                    templogical_right(m,k)=temp==filtersettings{k,12};
                end
            end
% % % % %  three columns of filters  % % % % % %

            if strcmpi(filtersettings(k,5),'DONE')
                finallogical(m,k)=templogical_left(m,k);
                
            elseif strcmpi(filtersettings(k,5),'&&')
                    
                    if strcmpi(filtersettings(k,9),'&&')                 
                          if (templogical_left(m,k)==0) || (templogical_middle(m,k)==0) || (templogical_right(m,k)==0)
                            finallogical(m,k)=0;
                          else
                            finallogical(m,k)=1;
                          end           
                   elseif strcmpi(filtersettings(k,9),'||')                  
                          if (templogical_left(m,k)==0) || (templogical_middle(m,k)==0) 
                            finallogical(m,k)=0;
                          else
                             finallogical(m,k)=1;
                          end 
                          if (templogical_right(m,k)==1)
                               finallogical(m,k)=1;
                          end                 
                   else                    
                          if (templogical_left(m,k)==0) || (templogical_middle(m,k)==0)
                            finallogical(m,k)=0;
                          else
                            finallogical(m,k)=1;
                          end
                   end
                
            elseif strcmpi(filtersettings(k,5),'||')
                
                  if strcmpi(filtersettings(k,9),'||')
                
                        if (templogical_left(m,k)==1) || (templogical_middle(m,k)==1) || (templogical_right(m,k)==1)
                          finallogical(m,k)=1;
                        else
                          finallogical(m,k)=0;
                        end
                  elseif strcmpi(filtersettings(k,9),'&&')  
                        if (templogical_right(m,k)==0)
                          finallogical(m,k)=0;
                        else
                           if (templogical_left(m,k)==1) || (templogical_middle(m,k)==1) 
                              finallogical(m,k)=1;
                           else
                              finallogical(m,k)=0;
                           end
                        end     
                 else
                        if (templogical_left(m,k)==1) || (templogical_middle(m,k)==1) 
                            finallogical(m,k)=1;
                        else
                            finallogical(m,k)=0;
                        end
                  end 
            end            
          
         end
       else filternames{k,1}='not assigned';
       end
    end
end

filternames{end+1,1}='multiple classes assigned';


for r=1:size(finallogical,1)
  
    output(r,7)=exportmat_editted{r,21};
    output(r,6)=0;
    loc_positive=0;
    loc_positive=find(finallogical(r,1:end-1));
%     r
    if ismember(loc_positive,find(shown_index))
       output(r,6)=1;
    end
    
    if sum(finallogical(r,1:end-1),2)==0
        output(r,4)=1;
        output(r,5)=0.2;
    elseif sum(finallogical(r,1:end-1),2)==1
        indtrue=find(finallogical(r,:)==1);
        output(r,4)=indtrue+1;
        output(r,5)=exportmat{r,22};
        if test_inhibition && output(r,7)
            output(r,4)=output(r,4)+3;
        end
    else
        output(r,4)=number_of_colors+1;
        output(r,5)=0.7;
    end
      
% % % % % %   added on 2017/10/06   % % % % % % % % % % % 
    if get(handles.Pop_RF_Type,'Value')==2  % select small RF cells  
        if exportmat{r,22}~=1
          output(r,4)=0;  
        end        
    end
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % %   
end

output(:,8)=cell2mat(exportmat(:,6));       % 2017/06/28   add the location of the cells to the 8th column of the matrix

cell_number=size(output,1);

if get(handles.Show_Boundary,'Value')
    h_cam=show3dposition_5_with_boundary(new_output,get(handles.Label_Cell_Nummber,'Value'),region,showlegend,filternames,size(exportmat,1)); % show thwe boundary
else
    h_cam=show3dposition_5_131005_RF(output,get(handles.Label_Cell_Nummber,'Value'),1,showlegend,filternames,get(handles.Hide_Unclassified_Cells,'Value'),number_of_colors,Alpha_value,show_choice); % don't show boundary
end



% --- Executes on button press in Hide_Unclassified_Cells.
function Hide_Unclassified_Cells_Callback(hObject, eventdata, handles)
% hObject    handle to Hide_Unclassified_Cells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Hide_Unclassified_Cells


% --- Executes on button press in Show_Boundary.
function Show_Boundary_Callback(hObject, eventdata, handles)
% hObject    handle to Show_Boundary (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Show_Boundary


% --- Executes on button press in Label_Cell_Nummber.
function Label_Cell_Nummber_Callback(hObject, eventdata, handles)
% hObject    handle to Label_Cell_Nummber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Label_Cell_Nummber



function Edit_Alpha_RF_Callback(hObject, eventdata, handles)
% hObject    handle to Edit_Alpha_RF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Edit_Alpha_RF as text
%        str2double(get(hObject,'String')) returns contents of Edit_Alpha_RF as a double
global Alpha_value
Alpha_value=str2double(get(handles.Edit_Alpha_RF,'String'));

% --- Executes during object creation, after setting all properties.
function Edit_Alpha_RF_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Edit_Alpha_RF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in Pop_RF_Type.
function Pop_RF_Type_Callback(hObject, eventdata, handles)
% hObject    handle to Pop_RF_Type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Pop_RF_Type contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Pop_RF_Type


% --- Executes during object creation, after setting all properties.
function Pop_RF_Type_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Pop_RF_Type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_RF_output.
function pushbutton_RF_output_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_RF_output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global file path h_cam

if ishandle(98)
  figure(98);
  set(gcf, 'Position', [0 0 1920 1080])
  filename=[path file(1:end-14) datestr(now,'mmddyy') '_' datestr(now,'HHMMSS')];
  if get(handles.Show_Boundary,'Value')
      filename=[filename '_with_boundary'];
  end
  % fix aspect ratio
  axis vis3d;
  xlim([-130,130]);
  ylim([-220,40]);
  zlim([-100,150]);

  view(270,90);
        	camlight(h_cam,'headlight')
  saveas(98,[filename '_frontal'], 'png');
  saveas(98,[filename '_frontal'], 'fig');
  

  view(270,0);
        	camlight(h_cam,'headlight')
  saveas(98,[filename '_sagittal'], 'png');
  saveas(98,[filename '_sagittal'], 'fig');

  view(180,0);
        	camlight(h_cam,'headlight')
  saveas(98,[filename '_transversal_front'], 'png');
  saveas(98,[filename '_transversal_front'], 'fig');
  
  msgbox('Operation Completed');
else
    errordlg('Please plot the cells first');
end


% --- Executes on button press in Test_Inhibition.
function Test_Inhibition_Callback(hObject, eventdata, handles)
% hObject    handle to Test_Inhibition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Test_Inhibition
global test_inhibition
test_inhibition=get(handles.Test_Inhibition,'Value');


% --- Executes on button press in radiobutton_All.
function radiobutton_All_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_All (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_All
guidata(hObject, handles);
if get(hObject,'Value') 
    set(handles.radiobutton_Pretectum,'Value',0)
    set(handles.radiobutton_Tectum,'Value',0)
end

% --- Executes on button press in radiobutton_Tectum.
function radiobutton_Tectum_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Tectum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_Tectum
guidata(hObject, handles);
if get(hObject,'Value') 
    set(handles.radiobutton_All,'Value',0)
    set(handles.radiobutton_Pretectum,'Value',0)
end

% --- Executes on button press in radiobutton_Pretectum.
function radiobutton_Pretectum_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Pretectum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_Pretectum
guidata(hObject, handles);
if get(hObject,'Value') 
    set(handles.radiobutton_All,'Value',0)
    set(handles.radiobutton_Tectum,'Value',0)
end


% --- Executes during object creation, after setting all properties.
function Show_Cells_RF_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Show_Cells_RF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
