%%% This script enables the user to load multiple .mat files, and
%%% concatenate the variable "exportmat" of all files vertically. The user
%%% is then prompted to save the resulting array to a .mat file.
%%% Bastian Hablitzel, April 2013

[files, pathname, filterindex] = uigetfile( ...
{  '*.mat','MAT-files (*.mat)'; ...
   '*.*',  'All Files (*.*)'}, ...
   'Open multiple exportmat files to pool your data of the whole brain', ...
   'MultiSelect', 'on');
if( isempty( files ) )
    var = [];
    return;
end

varname='exportmat';
% var = load( files{1}, varname ); Bastian
var = load(fullfile(pathname, files{1}), varname ); %Christian (independent from path)
var = var.(varname);

for f = 2:numel(files),
%     newvar = load( files{f}, varname ); %Bastian
    newvar = load(fullfile(pathname, files{f}), varname ); %Christian (independent form path)
        if( isfield( newvar, varname ) )
            var = cat(1, var, newvar.(varname) );
        else
            warning('FileCat:VarMissing', ['Warning: File ' files{f} ' does not contain variable ' varname ] );
        end
end
exportmat=var;
% [SaveFileName,SavePathName] = uiputfile;
[SaveFileName,SavePathName] = uiputfile('Rec_pooled_data_of_the brain_.mat','name the new file'); % Kun
save([SavePathName,SaveFileName],'exportmat');




