function [HfigAndAxes]=showROIs()
hMainFigure = figure(...       % The main GUI figure
    'MenuBar','none', ...
    'Toolbar','none', ...
    'HandleVisibility','callback', ...
    'Position', [100 100 600 600], ...
    'Color', get(0,...
    'defaultuicontrolbackgroundcolor')); ...
    fighandle=gcf;

%% Generate Axes
hImageAxes = axes(...    % Axes for plotting the Image
    'Parent', hMainFigure, ...
    'Units', 'normalized', ...
    'HandleVisibility','callback', ...
    'Position',[0 0 1 1], ...
    'yticklabel', []); ...
    title('Stack');
    imgaxis=gca;
    
    HfigAndAxes=[fighandle, imgaxis];


%% Image Menu
hImageMenu      =   uimenu(...       % Image
    'Parent',hMainFigure,...
    'HandleVisibility','callback', ...
    'Label','Image');
hadjAdjustContrast  =   uimenu(...       % Adjust stack contrast
    'Parent',hImageMenu,...
    'Label','Adjust stack contrast',...
    'HandleVisibility','callback', ...
    'Callback', {@hAdjContrast, HfigAndAxes});
end

function hAdjContrast(~, ~, HfigAndAxes)
figure(HfigAndAxes(1));
axes(HfigAndAxes(2));
imcontrast;
end