function [HfigAndAxes] = stackslicealign()
hMainFigure = figure(...       % The main GUI figure
    'MenuBar','none', ...
    'Toolbar','none', ...
    'HandleVisibility','callback', ...
    'Position', [100 100 900 300], ...
    'Color', get(0,...
    'defaultuicontrolbackgroundcolor')); ...
    fighandle=gcf;

%% Generate Axes
hStackPlotAxes = axes(...    % Axes for plotting the Stack
    'Parent', hMainFigure, ...
    'Units', 'normalized', ...
    'HandleVisibility','callback', ...
    'Position',[0 0 0.33 1], ...
    'yticklabel', []); ...
    title('Stack');
    stackaxis=gca;
    
hSlicePlotAxes = axes(...    % Axes for plotting the Slice
    'Parent', hMainFigure, ...
    'Units', 'normalized', ...
    'HandleVisibility','callback', ...
    'Position',[0.33 0 0.33 1], ...
    'yticklabel', []);
    title('Slice');
    sliceaxis=gca;

hAlignPlotAxes = axes(...    % Axes for plotting the AlignedImages
    'Parent', hMainFigure, ...
    'Units', 'normalized', ...
    'HandleVisibility','callback', ...
    'Position',[0.66 0 0.33 1], ...
    'yticklabel', []);
    mergeaxis=gca;
    
HfigAndAxes=[fighandle, stackaxis, sliceaxis, mergeaxis];


%% Image Menu
hImageMenu      =   uimenu(...       % Image
    'Parent',hMainFigure,...
    'HandleVisibility','callback', ...
    'Label','Image');
hadjStackContrast  =   uimenu(...       % Adjust stack contrast
    'Parent',hImageMenu,...
    'Label','Adjust stack contrast',...
    'HandleVisibility','callback', ...
    'Callback', {@hAdjStackContrast HfigAndAxes});
hadjSliceContrast  =  uimenu(...       % Print menu item
    'Parent',hImageMenu,...
    'Label','Adjust slice contrast',...
    'HandleVisibility','callback', ...
    'Callback', {@hAdjSliceContrast HfigAndAxes});
end

function hAdjStackContrast(~, ~, HfigAndAxes)
figure(HfigAndAxes(1));
axes(HfigAndAxes(2));
imcontrast;
end

function hAdjSliceContrast(~, ~, HfigAndAxes)
figure(HfigAndAxes(1));
axes(HfigAndAxes(3));
imcontrast;
end